///home/berryj/link/bin/genMethods "-g" "-t" "int" "-h" "MSet" "-r" "Collection<int>" "-I" "LINK/basic/MSet.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/MSet.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef int _int;
typedef MSet<int > _MSet_int_;
static MSet<int > s__MSet_int_;

#define _MSet_int_DATA(x) ((MSet<int >*) (EXTDATA(x)))
#define _MSet_int_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<int > >::type))
#define _MSet_int_ISNT_DATA(x) (!_MSet_int_IS_DATA(x))

#define _MSet_int_CXX_DATA(x) (*(MSet<int >*) (EXTDATA(VAL(x))))
#define _MSet_int_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<int > >::type))
#define _MSet_int_CXX_ISNT_DATA(x) (!_MSet_int_CXX_IS_DATA(x))


PRIMITIVE STk_init__MSet_int_()
{
	Wrapper<_MSet_int_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MSet_int_>::name, 
			Wrapper<Collection<int> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_int>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_int>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_int>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_MSet_int_>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_MSet_int_Methods(void);

PRIMITIVE STk_init_methods__MSet_int_()
{
	genExtra_MSet_int_Methods();
	return UNDEFINED;
}
